RemotingConnection (ActiveMQ Artemis Web 1.1.0.wildfly-010 API)
Date: 2015-12-18

org.apache.activemq.artemis.spi.core.protocol

## Interface RemotingConnection

- All Superinterfaces:
    BufferHandler
  All Known Implementing Classes:
    AbstractRemotingConnection

      public interface RemotingConnection
      extends BufferHandler

  A RemotingConnection is a connection between a client and a server. Perhaps a better name for this class now would be ProtocolConnection as this represents the link with the used protocol

- - ### Method Summary

    All Methods Instance Methods Abstract Methods
    Modifier and Type | Method and Description
    --- | ---
    `void` | `addCloseListener(org.apache.activemq.artemis.core.remoting.CloseListener listener)` add a CloseListener.
    `void` | `addFailureListener(org.apache.activemq.artemis.core.remoting.FailureListener listener)` add a failure listener.
    `boolean` | `checkDataReceived()` returns true if any data has been received since the last time this method was called.
    `ActiveMQBuffer` | `createTransportBuffer(int size)` creates a new ActiveMQBuffer of the specified size.
    `void` | `destroy()` destroys this connection.
    `void` | `disconnect(boolean criticalError)` Disconnect the connection, closing all channels
    `void` | `disconnect(String scaleDownNodeID, boolean criticalError)` Disconnect the connection, closing all channels
    `void` | `fail(ActiveMQException me)` called when the underlying connection fails.
    `void` | `fail(ActiveMQException me, String scaleDownTargetNodeID)` called when the underlying connection fails.
    `void` | `flush()` flush all outstanding data from the connection.
    `long` | `getCreationTime()` Returns the creation time of the `RemotingConnection`.
    `List<org.apache.activemq.artemis.core.remoting.FailureListener>` | `getFailureListeners()` return all the failure listeners
    `Object` | `getID()` Returns the unique id of the `RemotingConnection`.
    `String` | `getRemoteAddress()` returns a string representation of the remote address of this connection
    `Connection` | `getTransportConnection()` return the underlying Connection.
    `boolean` | `isClient()` Returns whether or not the `RemotingConnection` is a client
    `boolean` | `isDestroyed()` Returns true if this `RemotingConnection` has been destroyed.
    `boolean` | `isWritable(ReadyListener callback)`
    `boolean` | `removeCloseListener(org.apache.activemq.artemis.core.remoting.CloseListener listener)` remove a Close Listener
    `List<org.apache.activemq.artemis.core.remoting.CloseListener>` | `removeCloseListeners()`
    `boolean` | `removeFailureListener(org.apache.activemq.artemis.core.remoting.FailureListener listener)` remove the failure listener
    `List<org.apache.activemq.artemis.core.remoting.FailureListener>` | `removeFailureListeners()`
    `void` | `setCloseListeners(List<org.apache.activemq.artemis.core.remoting.CloseListener> listeners)`
    `void` | `setFailureListeners(List<org.apache.activemq.artemis.core.remoting.FailureListener> listeners)` set the failure listeners.

    - ### Methods inherited from interface org.apache.activemq.artemis.spi.core.remoting.BufferHandler

      `bufferReceived`

- - ### Method Detail

    - #### getID

          Object getID()

      Returns the unique id of the `RemotingConnection`.
      Returns:
        the id

    - #### getCreationTime

          long getCreationTime()

      Returns the creation time of the `RemotingConnection`.

    - #### getRemoteAddress

          String getRemoteAddress()

      returns a string representation of the remote address of this connection
      Returns:
        the remote address

    - #### addFailureListener

          void addFailureListener(org.apache.activemq.artemis.core.remoting.FailureListener listener)

      add a failure listener.

      The listener will be called in the event of connection failure.

      Parameters:
        `listener` - the listener

    - #### removeFailureListener

          boolean removeFailureListener(org.apache.activemq.artemis.core.remoting.FailureListener listener)

      remove the failure listener
      Parameters:
        `listener` - the lister to remove
      Returns:
        true if removed

    - #### addCloseListener

          void addCloseListener(org.apache.activemq.artemis.core.remoting.CloseListener listener)

      add a CloseListener.

      This will be called in the event of the connection being closed.

      Parameters:
        `listener` - the listener to add

    - #### removeCloseListener

          boolean removeCloseListener(org.apache.activemq.artemis.core.remoting.CloseListener listener)

      remove a Close Listener
      Parameters:
        `listener` - the listener to remove
      Returns:
        true if removed

    - #### removeCloseListeners

          List<org.apache.activemq.artemis.core.remoting.CloseListener> removeCloseListeners()

    - #### setCloseListeners

          void setCloseListeners(List<org.apache.activemq.artemis.core.remoting.CloseListener> listeners)

    - #### getFailureListeners

          List<org.apache.activemq.artemis.core.remoting.FailureListener> getFailureListeners()

      return all the failure listeners
      Returns:
        the listeners

    - #### removeFailureListeners

          List<org.apache.activemq.artemis.core.remoting.FailureListener> removeFailureListeners()

    - #### setFailureListeners

          void setFailureListeners(List<org.apache.activemq.artemis.core.remoting.FailureListener> listeners)

      set the failure listeners.

      These will be called in the event of the connection being closed. Any previosuly added listeners will be removed.

      Parameters:
        `listeners` - the listeners to add.

    - #### createTransportBuffer

          ActiveMQBuffer createTransportBuffer(int size)

      creates a new ActiveMQBuffer of the specified size. For the purpose of i/o outgoing packets
      Parameters:
        `size` - the size of buffer required
      Returns:
        the buffer

    - #### fail

          void fail(ActiveMQException me)

      called when the underlying connection fails.
      Parameters:
        `me` - the exception that caused the failure

    - #### fail

          void fail(ActiveMQException me,
                    String scaleDownTargetNodeID)

      called when the underlying connection fails.
      Parameters:
        `me` - the exception that caused the failure
        `scaleDownTargetNodeID` - the ID of the node where scale down is targeted

    - #### destroy

          void destroy()

      destroys this connection.

    - #### getTransportConnection

          Connection getTransportConnection()

      return the underlying Connection.
      Returns:
        the connection

    - #### isClient

          boolean isClient()

      Returns whether or not the `RemotingConnection` is a client
      Returns:
        true if client, false if a server

    - #### isDestroyed

          boolean isDestroyed()

      Returns true if this `RemotingConnection` has been destroyed.
      Returns:
        true if destroyed, otherwise false

    - #### disconnect

          void disconnect(boolean criticalError)

      Disconnect the connection, closing all channels

    - #### disconnect

          void disconnect(String scaleDownNodeID,
                          boolean criticalError)

      Disconnect the connection, closing all channels

    - #### checkDataReceived

          boolean checkDataReceived()

      returns true if any data has been received since the last time this method was called.
      Returns:
        true if data has been received.

    - #### flush

          void flush()

      flush all outstanding data from the connection.

    - #### isWritable

          boolean isWritable(ReadyListener callback)

Copyright © 2015. All rights reserved.